/**
 * @file AthenaPoolTestMapData.cxx 
 * 
 * @brief
 * 
 * @author RD Schaffer <R.D.Schaffer@cern.ch>
 * 
 * $Id: AthenaPoolTestMapData.cxx,v 1.1 2005/07/11 14:38:05 frankb Exp $
 */

//<<<<<< INCLUDES                                                       >>>>>>

#include "AthenaPoolTestMapData.h"
#include <iostream>

AthenaPoolTestMapData::AthenaPoolTestMapData() :
  m_word(0)
{
  
}

AthenaPoolTestMapData::AthenaPoolTestMapData (const std::vector<Deposit>& deposits, 
			    int simDataWord)
    : m_word(deposits.size()<<29 & 0xe0000000 | (simDataWord & 0x1fffffff))
{
    /*
    
    m_p_deposits = new Deposit[deposits.size()];
    
    for (unsigned int i = 0; i!= deposits.size(); i++)
    {
	m_p_deposits[i] = deposits[i];
    }
    */

    m_deposits = deposits;
}

AthenaPoolTestMapData::AthenaPoolTestMapData (const AthenaPoolTestMapData& other)
    :m_word(other.m_word),
     m_deposits(other.m_deposits)
{}


AthenaPoolTestMapData::~AthenaPoolTestMapData()
{
    //    delete[] m_p_deposits;
}

