#ifndef IDATASVCFACTORY_H
#define IDATASVCFACTORY_H

#include "DataSvc/IDataSvc.h"
#include <string>

namespace pool {

   // This class signature has been kept only for backward compatibility.
  class IDataSvcFactory 
  {
  public:
    static IDataSvcFactory* get();

    IDataSvc* create(const std::string& className,const DataSvcContext& ctx);
  private:
    IDataSvcFactory();
  };

}

#endif
