#ifndef DATASVC_IREGISTEREDREF_H
#define DATASVC_IREGISTEREDREF_H

namespace pool {

  class ICacheSvc;

  class CacheEntry;

  /** @class IRegisteredRef IRegisteredRef.h DataSvc/IRegisteredRef.h
    *
    */
  class IRegisteredRef {
  protected:
    /// Default destructor
    virtual ~IRegisteredRef() {}

  public:
    virtual void unregisterCacheSvc( ICacheSvc* cacheSvc ) = 0;

    virtual void unregisterCacheEntry( CacheEntry* cacheEntry) = 0;
  };

}

#endif
