// $Header: /cvs/PF/pool/DataSvc/tests/Common/FakeToken.h,v 1.6 2003/07/24 20:25:48 govi Exp $
#ifndef POOL_FAKETOKEN_H
#define POOL_FAKETOKEN_H

#include "POOLCore/Token.h"

namespace pool {

  class FakeToken : public Token {
  public:

	  FakeToken(long mainId):Token() { m_oid.second = mainId; };

	  FakeToken(FakeToken& copy): Token() {
         m_oid.second = copy.m_oid.second;
	  }

      FakeToken& operator=(FakeToken& copy){
         m_oid.second = copy.m_oid.second;
	     return *this;
	  }

      long release(){
        delete this;
        return 0;
      }

  };



} // namespace pool
#endif /// POOL_FAKETOKEN_H
