#ifndef OBJECTRELATIONALACCESS_OBJECTRELATIONALEXCEPTION_H
#define OBJECTRELATIONALACCESS_OBJECTRELATIONALEXCEPTION_H

#include "POOLCore/Exception.h"

namespace pool {

  /// Base exception class for the POOL relational layer
  class ObjectRelationalException : public pool::Exception {
  public:
    /// Constructor
    ObjectRelationalException( const std::string& message,
                               const std::string& methodName );
    /// Destructor
    virtual ~ObjectRelationalException() throw() {}
  };

}

#endif
