inline const std::string&
pool::ObjectRelationalMapping::version() const
{
  return m_version;
}

inline const std::string&
pool::ObjectRelationalMapping::className() const
{
  return m_className;
}

inline void 
pool::ObjectRelationalMapping::setVersion(const std::string& version)
{
  m_version = version;
}

inline const pool::ObjectRelationalMappingElement& 
pool::ObjectRelationalMapping::element() const {
  return m_element;
}

inline pool::ObjectRelationalMappingElement& 
pool::ObjectRelationalMapping::element(){
  return m_element;
}

inline const std::map< std::string, pool::ObjectRelationalMappingElement >& 
pool::ObjectRelationalMapping::dependentElements() const {
  return m_dependentElements;
}
inline std::map< std::string, pool::ObjectRelationalMappingElement >& 
pool::ObjectRelationalMapping::dependentElements() {
  return m_dependentElements;
}

inline size_t 
pool::ObjectRelationalMapping::numberOfDependentElements() const {
  return m_dependentElements.size();
}

