#include "DummySchema.h"

DummySchema::DummySchema():
  m_listOfTables()
{
  m_listOfTables.insert( "T_CLASS_A" );
  m_listOfTables.insert( "T_TABLE" );
  m_listOfTables.insert( "T_ANOTHER_TABLE" );
  m_listOfTables.insert( "T_CLASS_B" );
  m_listOfTables.insert( "T_CLASS_B_1" );
}

DummySchema::~DummySchema()
{}

std::string 
DummySchema::schemaName() const
{ 
  return "DummySchemaName";
}

std::set<std::string>
DummySchema::listTables() const
{
  return m_listOfTables;
}

bool
DummySchema::existsTable( const std::string& name ) const
{
  return ( m_listOfTables.find( name ) != m_listOfTables.end() );
}

coral::ITable&
DummySchema::createTable( const coral::ITableDescription& )
{
  coral::ITable* p = 0;
  return *p;
}

void
DummySchema::dropTable( const std::string& )
{}

void
DummySchema::truncateTable( const std::string& )
{}

void
DummySchema::callProcedure( const std::string&, const coral::AttributeList& )
{}

void
DummySchema::dropIfExistsTable( const std::string& )
{}

coral::ITable&
DummySchema::tableHandle( const std::string& )
{
  coral::ITable* p = 0;
  return *p;
}

coral::IQuery*
DummySchema::newQuery() const
{
  return 0;
}

coral::IViewFactory*
DummySchema::viewFactory()
{
  return 0;
}

bool
DummySchema::existsView(const std::string&) const 
{
  return false;
}

void
DummySchema::dropView(const std::string&)
{}

void
DummySchema::dropIfExistsView(const std::string&)
{}

std::set<std::string>
DummySchema::listViews() const
{
  return std::set<std::string>();
}

coral::IView&
DummySchema::viewHandle(const std::string&)
{
  coral::IView* view = 0;
  return *view;
}

