#include "DbIOHandler.h"
#include "RelationalPoolDatabase.h"
#include "StorageSvc/DbDatabase.h"

pool::RelationalStorageService::DbIOHandler::DbIOHandler( pool::DbDatabase* databaseHandle ):m_databaseContext(databaseHandle),
                                                                                             m_context(0){
  if(m_databaseContext){
    pool::IDbDatabase* idb = m_databaseContext->info();
    m_context = (dynamic_cast< pool::RelationalStorageService::RelationalPoolDatabase*>( idb ))->context();
  }
}
