#include "ObjectStorageTest/ObjectStorageTest.h"

namespace pool  {

class AppendReadTest : public ObjectStorageTest {
  private:

    int m_sequence_type;

  public: 
    enum SequenceType { WRITE, APPEND, READ, FULL };

    AppendReadTest(std::string& dbName1, const DbType& storage_type1,
                   std::string& dbName2, const DbType& storage_type2);

    bool compareExpected(std::string,unsigned int i,const TestClass& obj);
    bool compareExpected(unsigned int i,const TestClass& obj);

    void reWrite(unsigned int NC);

    void selectTestSequence(SequenceType type);

    void execute();

};


}



