#ifndef ABC_H
#define ABC_H


#include "DataSvc/Ref.h"
#include<vector>
#include<iostream>

namespace NavigationTests  {

struct AT{
  AT(){}
  virtual ~AT(){}
};

struct BT{
  BT(){}
  virtual ~BT(){}    
  int k;
};

class T2;

 class T1 : public AT, public BT {
 public:
    T1(){}
    virtual ~T1(){}    
    int j;
    pool::Ref<const T2> c;   
 };


class T2 : public AT {
public:
    T2(){}
    virtual ~T2(){}
    virtual void bha() {}
    std::vector<pool::Ref<AT> > bs;
};

struct S {

  int l;

};


  template<class T>
  struct AP {
    
    T t;
  };
  
  
  struct AS {
    AP<BT*> p;

  };

  struct A{
    static S s;
    A();
    virtual ~A();    
    int i;
    pool::Ref<A> previous;
  };
  
  struct AV : public A{
    AV(){}
    virtual ~AV(){}
    const AV * me() const { return this;}
    virtual size_t size() const = 0;
  };
  




  struct B;

  struct Tr{
    int j;
    void * p;
  };

  struct CC;

struct CBase {
  virtual ~CBase(){}

  virtual void bha(){}
  int kk;

};

  

  struct B : public A {

    static pool::IDataSvc * c_dsvc;
    B() : c(c_dsvc) {}
    explicit B(int jj) : j(jj) {}
    virtual ~B(){}    
    int j;
    pool::Ref<CC> c;   
    //    CC * tc_;
  };
  
  struct CC : public AV, public CBase {
    CC() {
      std::cout << "constr CC" << std::endl; 
    }
    virtual ~CC(){
      std::cout << "destr CC" << std::endl; 
    }
    size_t size() const { return bs.size();}
    virtual void bha() {}
    std::vector<pool::Ref<B> > bs;
    pool::Ref<CC> parent;
  };
  
 struct K  {
   K(){}
   virtual ~K(){}    
   double d;
   Tr t_;

 };
  
  template<typename T>
  struct D : public B {
    D(){}
    virtual ~D(){}    
    std::vector<T> data;    
    Tr * t_;
    // A* ta_;
  };

  struct H {
    static bool verbose;
    H();
    ~H();
    explicit H(int ii);
    H(const H&rh);
    H& operator=(const H&rh);
    
    int i;
  };
  
}


#endif
