#ifndef CROSSREFERENCECLASS
#define CROSSREFERENCECLASS

#include "DataSvc/Ref.h"
#include <string>

class RelatedClass;

class CrossReferenceClass  {

 private:
  long a;
  int b;
  int c;
  
  std::string s;

  static int next(); 

 public:

  pool::Ref<const RelatedClass > refRelated;

  CrossReferenceClass(int); 

  CrossReferenceClass(); 

  virtual ~CrossReferenceClass(); 

  const RelatedClass* related() const;

  void setRef(const RelatedClass* pObj);

  void resetRef();
  
  void setMessage(std::string& aMessage);

  std::string message() const;

  bool operator==(const CrossReferenceClass& obj) const;

};

#endif
