#include "TestRefClasses/TestClass.h"
    
bool TestClass::operator==(const TestClass& t) const {
  bool ret = true;
  if(a!=t.a) ret = false;
  if(b!=t.b) ret = false;
  if(c!=t.c) ret = false;
  if(d!=t.d) ret = false;

  if(m_ref){
    if(!t.m_ref){ 
      ret = false;
    } else {
      if(!equals(*m_ref,*(t.m_ref))) ret = false;
    }
  } else {
    if(t.m_ref) ret = false;
  }

  if(m_label!=t.m_label) ret = false;

  if(m_id.id!=t.m_id.id) ret = false;

  return ret;
}

void TestClass::dump() const {
  std::cout << "a="<<a<<std::endl;
  std::cout << "b="<<b<<std::endl;
  std::cout << "c="<<c<<std::endl;
  std::cout << "d="<<d<<std::endl;
  std::cout << "label="<<m_label<<std::endl;
  std::cout << "id="<<m_id.id<<std::endl;
  if(m_ref)
    std::cout << "TNamed name="<<m_ref->GetName()<<" title="<<m_ref->GetTitle()<<std::endl;
}

bool TestClass::equals(const TNamed& t1,const TNamed& t2) {
  bool ret = true;
  if(::strcmp(t1.GetTitle(),t2.GetTitle())>0) ret = false;
  if(::strcmp(t1.GetName(),t2.GetName())>0) ret = false;
  return ret;
}


