#ifndef TESTDRIVER_H
#define TESTDRIVER_H

#include <vector>
#include <string>

namespace pool {

  class TestDriver {
  public:
    TestDriver();
    ~TestDriver();
    void loadLibraries( const std::vector<std::string>& libraries );
    void write();
    void read();
  private:
    int                   m_events;
  };

}

#endif
