#ifndef TESTDRIVER_H
#define TESTDRIVER_H

#include "TestBase/TestBase.h"

namespace pool {
  
class TestDriver : public pool::TestBase
{
public:
  TestDriver( const std::string& connectionString );
  ~TestDriver();

  void cleanUp();

  void createDatabase(unsigned int nObjects);

  void readBackData(unsigned int nExpectedObjects );

  void updateData(unsigned int nExpectedObjects, unsigned int updateOffset );

  void execute();

private:

  std::string m_connectionString;

};

}

#endif
