import os
os.environ['CORAL_DBLOOKUP_PATH']='/afs/cern.ch/sw/lcg/app/pool/db'
os.environ['CORAL_AUTH_PATH']='/afs/cern.ch/sw/lcg/app/pool/db'

import coral
import time

locked = False

for i in range(360):
#  context = coral.Context()
#  context.setVerbosityLevel( 'ERROR' )
  connectionService = coral.ConnectionService(  )
  session = connectionService.connect( '/pool/db/service_1' )
  transaction = session.transaction()
  transaction.start()
  schema = session.nominalSchema()
  if schema.existsTable( 'TESTS_LOCK' ):
    time.sleep(10)
  else:
    description = coral.TableDescription()
    description.setName( 'TESTS_LOCK' )
    description.insertColumn( 'i','int')
    schema.createTable( description )
    locked = True
  transaction.commit()
  if locked: break

if not locked:
  raise Exception, 'Not managed to lock tests'
