#include "PersistencySvc/IDataTransformFactory.h"
#include "DataTransform.h"

pool::IDataTransformFactory::IDataTransformFactory(){}

pool::IDataTransform* pool::IDataTransformFactory::create(const std::string& className){
  IDataTransform* ret = 0;
  if(className=="DataTransform") ret = new pool::PersistencySvc::DataTransform();
  return ret;
}

pool::IDataTransformFactory*
pool::IDataTransformFactory::get()
{
  static pool::IDataTransformFactory s_instance;
  return &s_instance;
}
