#include "PersistencySvc/ITokenValidatorFactory.h"
#include "DummyTokenValidator.h"

pool::ITokenValidatorFactory::ITokenValidatorFactory(){}

pool::ITokenValidator* pool::ITokenValidatorFactory::create(const std::string& className){
  ITokenValidator* ret = 0;
  if(className=="DummyTokenValidator") ret = new pool::PersistencySvc::DummyTokenValidator();
  return ret;

}

pool::ITokenValidatorFactory*
pool::ITokenValidatorFactory::get()
{
  static pool::ITokenValidatorFactory s_instance;
  return &s_instance;
}
