#include "RelationalDomain.h"
#include "RelationalPoolDatabase.h"
#include "RelationalStorageServiceException.h"
#include "CoralBase/MessageStream.h"

pool::RelationalStorageService::RelationalDomain::RelationalDomain( pool::IOODatabase* idb,
                                                                    pool::Context* context ):
  pool::DbDomainImp(idb),
  m_context( context )
{}


pool::RelationalStorageService::RelationalDomain::~RelationalDomain()
{}


bool
pool::RelationalStorageService::RelationalDomain::existsDbase( const std::string& name )
{
  return pool::RelationalStorageService::RelationalPoolDatabase::exists( name, m_context );
}
