// $Id: DbString.h,v 1.6 2007/11/20 18:10:06 frankb Exp $
//====================================================================
//
//  @author      M.Frank
//====================================================================
#ifndef POOL_DBSTRING_H
#define POOL_DBSTRING_H 1

// Framework include files
#include "StorageSvc/DbObject.h"

/*
 * POOL namespace declaration
 */
namespace pool  {
  /// Declaration of DbString class
  class DbString POOL_BASE1(public std::string)  {
  public:
    /// Standard Constructor
    DbString() {}
    /// Constructor with initializer
    DbString(const std::string& s) {  assign(s); }
    /// Standard destructor
    virtual ~DbString() {}
  };
}
#endif // POOL_DBSTRING_H
