#include "TestBase/TestBase.h"
#include "StorageSvc/DbType.h"
#include "StorageSvc/poolDb.h"

namespace pool  {

  class CircularRefTest : public TestBase {
    private:
    const std::string m_dbName;
    const DbType m_type;
    std::string m_fid;
    Token* tok1;
    Token* tok2;
    public: 
    CircularRefTest(std::string& dbName, const DbType& storage_type);
    Token* tok3;
    Token* tok4;

    //
    void write();

    void writeOnScope(unsigned int nw);

    void writeLoop();

    void readLoop();

    /// 
    void read();

    void execute();
  };

}

