#include "CrossReferenceClass.h"
#include "RelatedClass.h"

int CrossReferenceClass::next() 
{ static int cnt=0; return ++cnt; }

CrossReferenceClass::CrossReferenceClass(int) 
    { 
      a = 0;
      b = 0;
      c = 0;
    }

CrossReferenceClass::CrossReferenceClass() 
    {
      a=next(); 
      b=next(); 
      c=next(); 
    }

CrossReferenceClass::~CrossReferenceClass() 
    {
      refRelated = 0;
    }

const RelatedClass* CrossReferenceClass::related() const {
    return refRelated;
  }

void CrossReferenceClass::setRef(const RelatedClass* pObj)        {
    refRelated = pObj;
  }

void CrossReferenceClass::setMessage(std::string& aMessage){
  s = aMessage;
}

std::string CrossReferenceClass::message() const{
  return s;
}

bool CrossReferenceClass::operator==(const CrossReferenceClass& obj) const {
  bool ret = true;
  if(a!=obj.a) ret = false;
  if(b!=obj.b) ret = false;
  if(c!=obj.c) ret = false;
  if(s!=obj.s) ret = false;
  if(refRelated!=obj.refRelated) ret = false;  
  return ret;
}

void CrossReferenceClass::resetRef(){ 
  refRelated = 0; 
}
