
#include "RelatedClass.h"
#include "CrossReferenceClass.h"
#include <string>

int RelatedClass::next() 
    { static int cnt=0; return ++cnt; }

RelatedClass::RelatedClass(int) 
    { 
      a = 0;
      b = 0;
      c = 0;
    }

RelatedClass::RelatedClass() 
    {
      a=next(); 
      b=next(); 
      c=next(); 
    }

RelatedClass::~RelatedClass() 
    {
      refObject = 0;
    }

const CrossReferenceClass* RelatedClass::relObject() const {
    return refObject;
  }

void RelatedClass::setRef(const CrossReferenceClass* pObj){
  refObject = pObj;
}

void RelatedClass::resetRef(){ 
  refObject = 0;
}

void RelatedClass::setMessage(std::string& aMessage){
  s = aMessage;
}

std::string RelatedClass::message() const{
  return s;
}

