#ifndef REFTESTCLASS_H
#define REFTESTCLASS_H

#include <iostream>

using std::cout;
using std::endl;

class RefTestClass {
public:
  RefTestClass() {};
  RefTestClass(int nuData) { data_ = nuData; }
  virtual ~RefTestClass() { };

  void data(int nuData) { cout << "[OVAL] non-const data() set method called" << endl; data_ = nuData; }
  // as expected, this method breaks build! not really a test of POOL tho'
  //const int data(int nuData) const { cout << "[OVAL] const data() set method called" << endl; data_ = nuData; }

  const int data() const { cout << "[OVAL] const data() query method called" << endl; return data_; }
  int data() { cout << "[OVAL] non-const data() query method called" << endl; return data_; }

  bool operator==( const RefTestClass& rhs ) const;
      
private:
  int data_;
};

inline bool RefTestClass::operator==( const RefTestClass& rhs ) const
{
  return ( data_ == rhs.data() );
}

#endif  // REFTESTCLASS_H


