#include "TNamed.h"
#include <iostream>
class RootPtrMemberClass  {

 private:
  
  static long next() 
    { static long cnt=0; return ++cnt; }

  TNamed* m_named;

  long m_id;

  bool equals(const TNamed& t1,const TNamed& t2) {
    bool ret = true;
    if(::strcmp(t1.GetTitle(),t2.GetTitle())>0) ret = false;
    if(::strcmp(t1.GetName(),t2.GetName())>0) ret = false;
    return ret;
  }

 public:

  RootPtrMemberClass(long val): m_named(0),m_id(val){} 

  RootPtrMemberClass(): m_named(0), m_id(next()){} 

  virtual ~RootPtrMemberClass(){}
 
  long id(){
    return m_id;
  }

  const TNamed* named() const {
    return m_named;
  }

  void setTNamed(TNamed* aNamed){
    m_named = aNamed;
  }

  bool operator==(const RootPtrMemberClass& anObject){
    bool ret = true;
    if(m_id!=anObject.m_id)     ret = false;
    if(!m_named){
      if(anObject.m_named) ret = false;
    } else {
      if(!anObject.m_named){
        ret = false;
      } else {
        if(!equals(*m_named,*(anObject.m_named))) ret = false;
      }
    }
    return ret;
  }

  void dump() const {
    std::cout << "Id="<<m_id<<std::endl;
    if(m_named){
      std::cout << "Name="<<named()->GetName()<<std::endl;
      std::cout << "Title="<<named()->GetTitle()<<std::endl;
    }
  }

};

