#include "ObjectStorageTest/ObjectStorageTest.h"

class TNamed;

namespace pool  {

class WriteTwiceTest : public ObjectStorageTest {
  private:

    int m_sequence_type;

    pool::Guid m_classGuid;

    bool compareExpected(unsigned int i,const TNamed& obj);

  public: 
    enum SequenceType { WRITE, APPEND, READ, FULL };

    WriteTwiceTest(std::string& dbName1, const DbType& storage_type1,
                   std::string& dbName2, const DbType& storage_type2);

    bool compareExpected(unsigned int i,const TestClass& obj);
    bool compareExpected(std::string,unsigned int i,const TestClass& obj);

    void reWrite(unsigned int NC,unsigned int offset);

    void readNamed(unsigned int n_expected);

    void selectTestSequence(SequenceType type);

    void execute();

};


}



