#ifndef MYTESTCLASSES_H
#define MYTESTCLASSES_H

#include "DataSvc/Ref.h"

class MyBaseClass {
public:
  MyBaseClass():data( 0 ) {}
  virtual ~MyBaseClass() {}
  int data;
};

class MyDerivedClass : public MyBaseClass {
public:
  MyDerivedClass(): MyBaseClass(), extraData( 0 ) {}
  ~MyDerivedClass() {}
  int extraData;
};

class MyOtherClass {
public:
  MyOtherClass(): otherData( 0 ) {}
  virtual ~MyOtherClass() {}
  int otherData;
  pool::Ref<MyBaseClass> refToBase;
  pool::Ref<MyBaseClass> refToDerived;
};

#endif
