#ifndef CATALOGLOOKUPS_H
#define CATALOGLOOKUPS_H
#include <vector>
#include "FileCatalog/IFileCatalog.h"
class CatalogLookups{
 public:
  CatalogLookups();
  ~CatalogLookups();
  void openCatalog( const std::string& contactstr );
  void closeCatalog();
  
  void getMETAfiles( const std::string& DataType, const std::string& ownername, std::vector<std::string>& lfns ) const ;
  void getEVDfiles( const std::string& ownername, const std::string& datasetname , const std::string& evdtype,std::vector<std::string>& lfns ) const ;
  void getOtherfiles( const std::string& filecategory, const std::string& name,std::vector<std::string>& lfns) const ;
  void getFilesByOwner( const std::string& owner, std::vector<std::string>& lfns ) const ;
 private:
  pool::IFileCatalog* m_catalog;
};
#endif
