#ifndef ITOKENCACHE_H
#define ITOKENCACHE_H

#include "IDataCache.h"

namespace pool {
  class Token;
}

class ITokenCache : public IDataCache
{
public:
  virtual int registerToken( pool::Token* token ) = 0;
  virtual void registerKey( int index, const std::string& key ) = 0;
  virtual pool::Token* saveObject( const TargetObject* object ) = 0;
};


#endif
